moDraw.vehicles = {};

function moDraw.vehicles:setOpenPDA(self)
	moSetGetVehicles:setVehicles(self);
	if moVehicles ~= nil then
		if moSetGetGui.pdaVI.iconDesign and moSetGetGui.loadImages.vi then
			moDraw.vehicles:setOpenPDAIconDesign(self);
		else
			moDraw.vehicles:setOpenPDATextDesign(self);			
		end;
	end;
end;

function moDraw.vehicles:setOpenPDAIconDesign(self)
	local posX = moSetGetGui.pdaVI.posX;
	local posY = moSetGetGui.pdaVI.posY;	
	local size = moSetGetGui.pdaVI.size;
	local iconSizeText = size-0.0005;
	local up = moSetGetGui.pdaVI.upDisplay;
	local posH = 0.007;
	local posB = 0;
	local up = moSetGetGui.pdaVI.upDisplay;
	local distanceLine = moSetGetGui.pdaVI.distanceLine;
	local distance = moSetGetGui.pdaVI.distance;	
	local screenRatio = moSetGetGui.screenAspectRatio/1000;	
	local firstPosXY = posY-(size/1.17);
	if up then firstPosXY = posY+(size/1.17);end;
	local saveFirstY = firstPosXY-0.005;
	function nextLine(posNew, setLine, menue)		
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLineVI"], posX, firstPosXY-0.001, posB, 0.001); --posB old 0.035
			moSetGetGui["designLineVI"]:render();
		end;
		if not up then			
			firstPosXY = firstPosXY-(size+posNew);
			if not menue then
				posH = posH+(size+posNew);
			end;
			posY = posY-(size+posNew);
		else			
			firstPosXY = firstPosXY+(size+posNew);
			if not menue then
				posH = posH+(size+posNew);
			end;
			posY = posY+(size+posNew);
		end;		
	end;	
	--moSetGetGui["cfgVI"]:setPosition(posX, firstPosXY);
	--moSetGetGui["cfgVI"]:render();
	--nextLine(distance, distanceLine, true);
	if moVehicles ~= nil then		
		if moSetGetGui.pdaVI.backGround then moSetGetGui["designGroundVI"]:render();end;		
		for k,v in pairs(moVehicles) do
			local noticeColor = moSetGetGui.pdaVI.defaultColor;			
			if moVehicles[k] ~= nil then
				local vehicleTxt = "";
				local controllerName = "";
				setTextBold(false);
				if moVehicles[k].isControlled or moVehicles[k].hired or moVehicles[k].hiredC then setTextBold(true);end;
				if moVehicles[k].isControlled or moVehicles[k].hired or moSetGetGui.pdaVI.compactDisplay > 0 or moVehicles[k].hiredC then					 
					local compact = false;
					controllerName = moVehicles[k].controllerName;
					--if not moSetGetGui.pdaVI.fullPlayerName and string.len(moVehicles[k].controllerName) > 3 then controllerName = "";end;
					if moSetGetGui.pdaVI.fullPlayerName == 0 and string.len(moVehicles[k].controllerName) > 3 then controllerName = "";end;
					if moSetGetGui.pdaVI.fullPlayerName == 1 and string.len(moVehicles[k].controllerName) > 3 then controllerName = "P  ";end;
					vehicleTxt = controllerName;					
					if moSetGetGui.pdaVI.vehicleName == 1 then vehicleTxt = vehicleTxt.. " [".. moVehicles[k].name.. "] ";end;					
					--if moSetGetGui.pdaVI.vehicleName == 2 then vehicleTxt = vehicleTxt.. " [".. moVehicles[k].realName.. "] ";end;
					if moSetGetGui.pdaVI.vehicleName == 2 then
						if not string.find(moVehicles[k].typeDesc, "unknown") then vehicleTxt = vehicleTxt.. " [".. string.upper(moVehicles[k].typeDesc).. "] ";else vehicleTxt = vehicleTxt.. " [".. string.upper(moVehicles[k].vehicleType).. "] ";end;
					end;
					local foundFillLevel = false
					if moVehicles[k].fillLevelProzent ~= nil then --and tonumber(moVehicles[k].fillLevelProzent) > 0 then						
						local fillDisplayVehicle = moVehicles[k].fillLevelProzent.. "%";
						if moSetGetGui.pdaVI.seeFillLevel then fillDisplayVehicle = g_i18n:formatNumber(moVehicles[k].fillLevel).. "L";end;
						vehicleTxt = vehicleTxt.. moVehicles[k].fruitName.. ":".. fillDisplayVehicle;
						foundFillLevel = true;
						compact = true;
						noticeColor = moVehicles[k].warningCapacityColor;
					end;
					local implement = true;
					if moVehicles[k].attached ~= 0 then
						for a=1, moVehicles[k].attached do
							if moVehicles[k].attachedValues[a] ~= nil then
								if not string.find(moVehicles[k].attachedValues[a].vehicleType, "implement") and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then implement = false;end;
								if moVehicles[k].attachedValues[a].fillLevelProzent ~= nil then --and tonumber(moVehicles[k].attachedValues[a].fillLevelProzent) > 0 then								
									local fillDisplayAttach = moVehicles[k].attachedValues[a].fillLevelProzent.. "%";
									if moSetGetGui.pdaVI.seeFillLevel then fillDisplayAttach = g_i18n:formatNumber(moVehicles[k].attachedValues[a].fillLevel).. "L";end;
									if a == 1 or not foundFillLevel then									
										if not foundFillLevel then foundFillLevel = true;end;										
										vehicleTxt = vehicleTxt.. moVehicles[k].attachedValues[a].fruitName.. ":".. fillDisplayAttach;
										compact = true;
									else
										vehicleTxt = vehicleTxt.. " | ".. moVehicles[k].attachedValues[a].fruitName.. ":".. fillDisplayAttach;
										compact = true;
									end;									
									if moVehicles[k].attachedValues[a].seedsSprayer or string.find(moVehicles[k].attachedValues[a].vehicleType, "manureBarrelCultivator") then 
										if moVehicles[k].attachedValues[a].seedsSprayer then noticeColor = moVehicles[k].attachedValues[a].warningCapacityColor;end;
										if moSetGetGui.pdaVI.seeMoreInfo == 1 and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then											
											vehicleTxt = vehicleTxt.. "("..  moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									else
										if moSetGetGui.pdaVI.seeMoreInfo == 1 and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then											
											vehicleTxt = vehicleTxt.. "("..  moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									end;									
								else
									if moSetGetGui.pdaVI.seeMoreInfo == 1 then
										if not string.find(moVehicles[k].attachedValues[a].vehicleType, "implement") and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then											
											vehicleTxt = vehicleTxt.. "(".. moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									end;
								end;
							end;
						end;						
					end;
					local setCompact = false;
					--if string.len(vehicleTxt) >= 2 and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;end;
					if moVehicles[k].isMotorStarted and moSetGetGui.pdaVI.compactDisplay == 2 then setCompact = true;
					elseif compact and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;
					elseif moVehicles[k].attached > 0 and not implement and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;
					elseif moSetGetGui.pdaVI.compactDisplay == 3 then setCompact = true;end;
					if moVehicles[k].isControlled or moVehicles[k].hired or setCompact or moVehicles[k].hiredC then						
						setTextColor(unpack(moGuiExtras.colors['ls15']));
						local moreText = 0;
						local speedWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*8;
						local vehicleWidth = 0;
						if moSetGetGui.pdaVI.vehicleDisplay then vehicleWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*10;end;
						local crash = false;
						local fuel = false;
						local cpWait = false
						local repair = false;
						local fieldWidth = 0;
						if moSetGetGui.pdaVI.fieldDisplay then
							fieldWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*7;
							moSetGetGui["VIfield"]:setPosition(posX+0.002, firstPosXY);
							moSetGetGui["VIfield"]:render();
							if tonumber(moVehicles[k].field) > 0 then
								local sizeTemp = iconSizeText;
								setTextColor(unpack(moGuiExtras.colors['white']));
								if tonumber(moVehicles[k].field) > 99 then sizeTemp = sizeTemp-0.0005;end;
								renderText(posX+0.002, firstPosXY+0.001, sizeTemp, tostring(moVehicles[k].field));
							end;
						end;					
						if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningCpWait then						
							cpWait = true;
						end;
						if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningCollision or moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningWater then						
							crash = true;
							moSetGetGui["VIwarning"]:setPosition(posX+0.002+fieldWidth+0.001, firstPosXY-0.001);
							moSetGetGui["VIwarning"]:render();
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningFuelTank and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer >= 150 and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer < 300 then						
							fuel = true;
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRepair and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer > 300 and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer <= 450 then						
							repair = true;							
						end;
						if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningSpeed or cpWait and not crash then
							moSetGetGui:setBackgroundColor(moSetGetGui["VIpark"], moSetGetGui.pdaVI.warningColor4);
							if moVehicles[k].isMotorStarted then moSetGetGui:setBackgroundColor(moSetGetGui["VIpark"], moSetGetGui.pdaVI.warningColor0);end;
							if cpWait or moVehicles[k].hired and tonumber(moVehicles[k].speed) == 0 or moVehicles[k].waitingForTrailerToUnload then moSetGetGui:setBackgroundColor(moSetGetGui["VIpark"], moSetGetGui.pdaVI.warningColor2);end;						
							moSetGetGui["VIpark"]:setPosition(posX+0.002+fieldWidth+0.001, firstPosXY-0.001);						
							moSetGetGui["VIpark"]:render();						
						elseif not crash then						
							if tonumber(moVehicles[k].speed) == 0 and moVehicles[k].hired or moVehicles[k].waitingForTrailerToUnload then --moVehicles[k].isMotorStarted then
								moSetGetGui:setBackgroundColor(moSetGetGui["VIpark"], moSetGetGui.pdaVI.warningColor2);
								moSetGetGui["VIpark"]:setPosition(posX+0.002+fieldWidth+0.001, firstPosXY-0.001);						
								moSetGetGui["VIpark"]:render();	
							else
								setTextColor(unpack(moGuiExtras.colors['white']));
								moSetGetGui["VIspeed"]:setPosition(posX+0.002+fieldWidth+0.001, firstPosXY);
								moSetGetGui["VIspeed"]:render();
								renderText(posX+0.002+fieldWidth+0.002, firstPosXY+0.001, iconSizeText, tostring(moVehicles[k].speed));
							end;
						end;
						local setColorPlayer = moVehicles[k].isControlled or (moVehicles[k].isControlled and moVehicles[k].hired) or (moVehicles[k].isControlled and moVehicles[k].hiredC);
						local setColorPlayerIcon = string.len(moVehicles[k].controllerName) > 3;
						if moSetGetGui.pdaVI.vehicleDisplay then							
							if fuel then								
								moSetGetGui["VIfuel"]:setPosition(posX+0.003+fieldWidth+0.001+speedWidth, firstPosXY-0.0025);
								moSetGetGui["VIfuel"]:render();
							elseif repair then								
								moSetGetGui:setBackgroundColor(moSetGetGui["VIrepair"], moVehicles[k].warningDamageLevelColor);
								moSetGetGui["VIrepair"]:setPosition(posX+0.003+fieldWidth+0.001+speedWidth, firstPosXY-0.002);
								moSetGetGui["VIrepair"]:render();
							elseif string.find(moVehicles[k].vehicleType, "combine_animated") or string.find(moVehicles[k].vehicleType, "selfPropelledPotatoHarvester") then							
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIdrescher"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VIdrescher"]:setPosition(posX+0.001+fieldWidth+0.001+speedWidth, firstPosXY-0.005);					
								moSetGetGui["VIdrescher"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIdrescher"], moGuiExtras.colors['khaki']);end;
							elseif string.find(moVehicles[k].vehicleType, "telehandler") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItelehandler"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VItelehandler"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth, firstPosXY-0.003);					
								moSetGetGui["VItelehandler"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItelehandler"], moGuiExtras.colors['khaki']);end;
							elseif string.find(moVehicles[k].vehicleType, "wheelLoader") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIwheelloader"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VIwheelloader"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth, firstPosXY-0.003);					
								moSetGetGui["VIwheelloader"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIwheelloader"], moGuiExtras.colors['khaki']);end;
							elseif string.find(moVehicles[k].vehicleType, "frontLoader") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIfrontloader"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VIfrontloader"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth, firstPosXY-0.003);					
								moSetGetGui["VIfrontloader"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIfrontloader"], moGuiExtras.colors['khaki']);end;		
							elseif string.find(moVehicles[k].vehicleType, "tractor") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItractor"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VItractor"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth+0.001, firstPosXY-0.003);					
								moSetGetGui["VItractor"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItractor"], moGuiExtras.colors['khaki']);end;
							elseif string.find(moVehicles[k].typeDesc, "Train") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItrain"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VItrain"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth+0.001, firstPosXY-0.003);					
								moSetGetGui["VItrain"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VItrain"], moGuiExtras.colors['khaki']);end;
							elseif string.find(moVehicles[k].typeDesc, "Crane") then						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIcrane"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VIcrane"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth+0.001, firstPosXY-0.003);					
								moSetGetGui["VIcrane"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIcrane"], moGuiExtras.colors['khaki']);end;	
							else						
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIautorest"], moGuiExtras.colors['ls15']);end;
								moSetGetGui["VIautorest"]:setPosition(posX+0.002+fieldWidth+0.001+speedWidth+0.001, firstPosXY-0.003);					
								moSetGetGui["VIautorest"]:render();
								if setColorPlayerIcon then moSetGetGui:setBackgroundColor(moSetGetGui["VIautorest"], moGuiExtras.colors['khaki']);end;	
							end;							
						elseif fuel then
							vehicleWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*10
							moSetGetGui["VIfuel"]:setPosition(posX+0.003+fieldWidth+0.001+speedWidth, firstPosXY-0.0025);
							moSetGetGui["VIfuel"]:render();
						elseif repair then
							moSetGetGui:setBackgroundColor(moSetGetGui["VIrepair"], moVehicles[k].warningDamageLevelColor);
							vehicleWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*10
							moSetGetGui["VIrepair"]:setPosition(posX+0.003+fieldWidth+0.001+speedWidth, firstPosXY-0.002);
							moSetGetGui["VIrepair"]:render();	
						end;
						--setTextColor(unpack(moGuiExtras.colors['ls15']));
						--renderText(posX+0.002+fieldWidth+0.001+speedWidth+0.001, firstPosXY+0.001, 0.010, tostring(controllerName));
						posB = 0.001+fieldWidth+0.001+speedWidth+0.001+vehicleWidth
						moreText = posB+0.001; --size*3.5;												
						if setColorPlayer then
							--if not moSetGetGui.pdaVI.vehicleDisplay then noticeColor = moGuiExtras.colors['ls15'];end;							
							--moGuiExtras:searchMods(self)
							noticeColor = moGuiExtras.colors['ls15'];
							if moVehicles[k].controllerNameHired ~= g_currentMission.player.controllerName then 
								--noticeColor = moGuiExtras.colors['ls15'];
								setTextBold(false);
							end;
						end;
						if unpack(noticeColor) == nil then noticeColor = moSetGetGui.pdaVI.defaultColor;end;
						setTextColor(unpack(noticeColor));						
						if moSetGetGui.pdaVI.seeRentCar and not setColorPlayer and moGeneralSettings.modTables.mietMod ~= nil then							
							if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCar and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer > 300 then								
								setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "RC: "
								for a=1, #moVehicles[k].rentCarTime do
									if moVehicles[k].rentCarOverTime[a] then
										vehicleTxt = vehicleTxt.. "(OverTime ".. tostring(moVehicles[k].rentCarOverTimePrice[a]).. " pro h-".. tostring(moVehicles[k].rentCarTime[a]).. "h)";
									elseif tonumber(moVehicles[k].rentCarTimeWarningColor[a]) >= 3 then
										vehicleTxt = vehicleTxt.. "(! ".. tostring(moVehicles[k].rentCarTime[a]).. "h !)";
									else
										vehicleTxt = vehicleTxt.. "(".. tostring(moVehicles[k].rentCarTime[a]).. "h)";
									end;
								end;								
							elseif moVehicles[k].rentCarTime ~= nil and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer <= 300 then
								--setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "[".. tostring(Utils.getNoNil(#moVehicles[k].rentCarTime, 1)).. " RC]".. vehicleTxt;
							elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer > 300 then
								setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "RC: "
								for a=1, #moVehicles[k].rentCarTime do									
									vehicleTxt = vehicleTxt.. "(".. tostring(moVehicles[k].rentCarTime[a]).. "h)";									
								end;
							end;
						end;						
						renderText(posX+(moreText), firstPosXY+0.002, size, tostring(vehicleTxt));
						if moVehicles[k].area ~= nil then
							moVehicles[k].area = {posX, posX+posB, firstPosXY+0.002, firstPosXY+0.002+(size+distance)};
						end;
						nextLine(distance, distanceLine, false);
					end;
				end;				
			end;
		end;
		if moSetGetGui.pdaVI.backGround then 
			if not up then 
				moSetGetGui:setOverlay(self, moSetGetGui["designGroundVI"], posX, posY, posB, posH);
			else
				moSetGetGui:setOverlay(self, moSetGetGui["designGroundVI"], posX, saveFirstY, posB, posH);
			end; --0.025 speed and field
		end;
	end;	
	setTextBold(false);
end;

function moDraw.vehicles:setOpenPDATextDesign(self)
	local posX = moSetGetGui.pdaVI.posX;
	local posY = moSetGetGui.pdaVI.posY;	
	local size = moSetGetGui.pdaVI.size;	
	local distanceLine = moSetGetGui.pdaVI.distanceLine;
	local distance = moSetGetGui.pdaVI.distance;
	if not moSetGetGui.loadImages.vi and distanceLine then return;end;
	local up = moSetGetGui.pdaVI.upDisplay;
	local screenRatio = moSetGetGui.screenAspectRatio/1000	
	local firstPosXY = posY-(size/1.17);
	if up then firstPosXY = posY+(size/1.17);end;
	function nextLine(posNew, setLine)		
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLineVI"], posX, firstPosXY-0.001, posB, 0.001); --posB old 0.035
			moSetGetGui["designLineVI"]:render();
		end;
		if not up then			
			firstPosXY = firstPosXY-(size+posNew);		
			posY = posY-(size+posNew);
		else			
			firstPosXY = firstPosXY+(size+posNew);		
			posY = posY+(size+posNew);			
		end;		
	end;
	--moSetGetGui["cfgVI"]:setPosition(posX, firstPosXY);
	--moSetGetGui["cfgVI"]:render();
	--nextLine(distance, distanceLine);	
	if moVehicles ~= nil then		
		for k,v in pairs(moVehicles) do
			local noticeColor = moSetGetGui.pdaVI.defaultColor;			
			if moVehicles[k] ~= nil then
				local vehicleTxt = "";
				local controllerName = "";
				setTextBold(false);
				if moVehicles[k].isControlled or moVehicles[k].hired or moVehicles[k].hiredC then setTextBold(true);end;
				if moVehicles[k].isControlled or moVehicles[k].hired or moSetGetGui.pdaVI.compactDisplay > 0 or moVehicles[k].hiredC then					
					local compact = false;
					controllerName = moVehicles[k].controllerName;					
					--if not moSetGetGui.pdaVI.fullPlayerName and string.len(moVehicles[k].controllerName) > 3 then controllerName = "P  ";end;
					if moSetGetGui.pdaVI.fullPlayerName == 0 and string.len(moVehicles[k].controllerName) > 3 then controllerName = "";end;
					if moSetGetGui.pdaVI.fullPlayerName == 1 and string.len(moVehicles[k].controllerName) > 3 then controllerName = "P  ";end;
					if moSetGetGui.pdaVI.speedDisplay and moSetGetGui.pdaVI.fieldDisplay then 
						controllerName = controllerName.. " F".. moVehicles[k].field.. "|".. moVehicles[k].speed.. " ".. g_i18n.globalI18N:getSpeedMeasuringUnit();
					elseif moSetGetGui.pdaVI.fieldDisplay then controllerName = controllerName.. " F".. moVehicles[k].field;
					elseif moSetGetGui.pdaVI.speedDisplay then controllerName = controllerName.. " ".. moVehicles[k].speed.. " ".. g_i18n.globalI18N:getSpeedMeasuringUnit();
					end;									
					vehicleTxt = controllerName;					
					if moSetGetGui.pdaVI.vehicleName == 1 then vehicleTxt = vehicleTxt.. " [".. moVehicles[k].name.. "] ";end;
					--if moSetGetGui.pdaVI.vehicleName == 2 then vehicleTxt = vehicleTxt.. " [".. moVehicles[k].realName.. "] ";end;
					if moSetGetGui.pdaVI.vehicleName == 2 then
						if not string.find(moVehicles[k].typeDesc, "unknown") then vehicleTxt = vehicleTxt.. " [".. string.upper(moVehicles[k].typeDesc).. "] ";else	vehicleTxt = vehicleTxt.. " [".. string.upper(moVehicles[k].vehicleType).. "] ";end;
					end;
					local foundFillLevel = false
					if moVehicles[k].fillLevelProzent ~= nil then --and tonumber(moVehicles[k].fillLevelProzent) > 0 then						
						local fillDisplayVehicle = moVehicles[k].fillLevelProzent.. "%";
						if moSetGetGui.pdaVI.seeFillLevel then fillDisplayVehicle = g_i18n:formatNumber(moVehicles[k].fillLevel).. "L";end;						
						if moSetGetGui.pdaVI.vehicleName == 0 then
							vehicleTxt = vehicleTxt.. " | ".. moVehicles[k].fruitName.. ":".. fillDisplayVehicle;							
						else
							vehicleTxt = vehicleTxt.. moVehicles[k].fruitName.. ":".. fillDisplayVehicle;
						end;
						compact = true;
						foundFillLevel = true;
						noticeColor = moVehicles[k].warningCapacityColor;
					end;					
					local implement = true;
					if moVehicles[k].attached ~= 0 then
						for a=1, moVehicles[k].attached do
							if moVehicles[k].attachedValues[a] ~= nil then
								if not string.find(moVehicles[k].attachedValues[a].vehicleType, "implement") and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then implement = false;end;
								if moVehicles[k].attachedValues[a].fillLevelProzent ~= nil then --and tonumber(moVehicles[k].attachedValues[a].fillLevelProzent) > 0 then								
									local fillDisplayAttach = moVehicles[k].attachedValues[a].fillLevelProzent.. "%";
									if moSetGetGui.pdaVI.seeFillLevel then fillDisplayAttach = g_i18n:formatNumber(moVehicles[k].attachedValues[a].fillLevel).. "L";end;					
									if a == 1 or not foundFillLevel then									
										if not foundFillLevel then foundFillLevel = true;end;
										compact = true;
										if moSetGetGui.pdaVI.vehicleName == 0 then
											vehicleTxt = vehicleTxt.. " | ".. moVehicles[k].attachedValues[a].fruitName.. ":".. fillDisplayAttach;	
										else
											vehicleTxt = vehicleTxt.. moVehicles[k].attachedValues[a].fruitName.. ":".. fillDisplayAttach;	
										end;																		
									else
										vehicleTxt = vehicleTxt.. " | ".. moVehicles[k].attachedValues[a].fruitName.. ":".. fillDisplayAttach;
										compact = true;
									end;									
									if moVehicles[k].attachedValues[a].seedsSprayer or string.find(moVehicles[k].attachedValues[a].vehicleType, "manureBarrelCultivator") then 
										if moVehicles[k].attachedValues[a].seedsSprayer then noticeColor = moVehicles[k].attachedValues[a].warningCapacityColor;end;
										if moSetGetGui.pdaVI.seeMoreInfo == 1 and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then
											if moSetGetGui.pdaVI.vehicleName == 0 then vehicleTxt = vehicleTxt.. " ";end;
											vehicleTxt = vehicleTxt.. "("..  moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									else
										if moSetGetGui.pdaVI.seeMoreInfo == 1 and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then
											if moSetGetGui.pdaVI.vehicleName == 0 then vehicleTxt = vehicleTxt.. " ";end;
											vehicleTxt = vehicleTxt.. "("..  moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									end;									
								else
									if moSetGetGui.pdaVI.seeMoreInfo == 1 then
										if not string.find(moVehicles[k].attachedValues[a].vehicleType, "implement") and not string.find(moVehicles[k].attachedValues[a].typeDesc, "unknown") then										
											if moSetGetGui.pdaVI.vehicleName == 0 then vehicleTxt = vehicleTxt.. " ";end;
											vehicleTxt = vehicleTxt.. "(".. moVehicles[k].attachedValues[a].typeDesc.. ")";
											compact = true;
										end;
									end;
								end;
							end;
						end;						
					end;
					local setCompact = false;
					--if compact and string.len(vehicleTxt) >= 2 and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;end;
					if moVehicles[k].isMotorStarted and moSetGetGui.pdaVI.compactDisplay == 2 then setCompact = true;
					elseif compact and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;
					elseif moVehicles[k].attached > 0 and not implement and moSetGetGui.pdaVI.compactDisplay == 1 then setCompact = true;
					elseif moSetGetGui.pdaVI.compactDisplay == 3 then setCompact = true;end;
					if moVehicles[k].isControlled or moVehicles[k].hired or setCompact or moVehicles[k].hiredC then
						setTextColor(unpack(moGuiExtras.colors['ls15']));
						local moreText = 0;
						--renderText(posX, firstPosXY, size, tostring("(splash) "));					 
						if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningWater then
							moreText = size*2.4;
							renderText(posX, firstPosXY, size, "(water) ");
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningCpWait or moVehicles[k].waitingForTrailerToUnload then
							moreText = size+screenRatio;
							setTextColor(unpack(moSetGetGui.pdaVI.warningColor2));
							renderText(posX, firstPosXY, size, "(P) ");
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningCollision then
							moreText = size*2.4;
							renderText(posX, firstPosXY, size, "(crash) ");
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningFuelTank and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer >= 150 and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer <= 300 then
							moreText = size*2.4;
							renderText(posX, firstPosXY, size, "(fuel) ");
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRepair and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer > 300 and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].blinkTimer <= 450 then
							setTextColor(unpack(moVehicles[k].warningDamageLevelColor));
							moreText = size*2.5;
							renderText(posX, firstPosXY, size, "(repair) ")	
						elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningSpeed then
							setTextColor(unpack(moSetGetGui.pdaVI.warningColor4));
							if moVehicles[k].isMotorStarted then setTextColor(unpack(moSetGetGui.pdaVI.warningColor0));end;
							if moVehicles[k].hired and tonumber(moVehicles[k].speed) == 0 and not crash then setTextColor(unpack(moSetGetGui.pdaVI.warningColor2));end;
							moreText = size+screenRatio;							
							renderText(posX, firstPosXY, size, "(P) ");							
						elseif moVehicles[k].hired and tonumber(moVehicles[k].speed) == 0 and not crash and not moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningSpeed then
							setTextColor(unpack(moSetGetGui.pdaVI.warningColor2));
							moreText = size+screenRatio;							
							renderText(posX, firstPosXY, size, "(P) ");							
						end;
						local setColorPlayer = false;
						if moVehicles[k].isControlled or (moVehicles[k].isControlled and moVehicles[k].hired) or (moVehicles[k].isControlled and moVehicles[k].hiredC) then
							noticeColor = moGuiExtras.colors['ls15'];
							setColorPlayer = true;
							if moVehicles[k].controllerNameHired ~= g_currentMission.player.controllerName then setTextBold(false);end;
						end;
						if unpack(noticeColor) == nil then noticeColor = moSetGetGui.pdaVI.defaultColor;end;
						setTextColor(unpack(noticeColor));
						if moSetGetGui.pdaVI.seeRentCar and not setColorPlayer and moGeneralSettings.modTables.mietMod ~= nil then							
							if moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCar and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer > 300 then								
								setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "RC: "
								for a=1, #moVehicles[k].rentCarTime do
									if moVehicles[k].rentCarOverTime[a] then
										vehicleTxt = vehicleTxt.. "(OverTime ".. tostring(moVehicles[k].rentCarOverTimePrice[a]).. " pro h-".. tostring(moVehicles[k].rentCarTime[a]).. "h)";
									elseif tonumber(moVehicles[k].rentCarTimeWarningColor[a]) >= 3 then
										vehicleTxt = vehicleTxt.. "(! ".. tostring(moVehicles[k].rentCarTime[a]).. "h !)";
									else
										vehicleTxt = vehicleTxt.. "(".. tostring(moVehicles[k].rentCarTime[a]).. "h)";
									end;
								end;								
							elseif moVehicles[k].rentCarTime ~= nil and moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer <= 300 then
								--setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "[".. tostring(Utils.getNoNil(#moVehicles[k].rentCarTime, 1)).. " RC]".. vehicleTxt;
							elseif moGeneralSettings.vehicleControlled[2][moVehicles[k].rootNode].warningRentCarTimer > 300 then
								setTextColor(unpack(moVehicles[k].warningRentCarTimeColor));
								vehicleTxt = "RC: "
								for a=1, #moVehicles[k].rentCarTime do									
									vehicleTxt = vehicleTxt.. "(".. tostring(moVehicles[k].rentCarTime[a]).. "h)";									
								end;
							end;
						end;
						renderText(posX+(moreText), firstPosXY, size, tostring(vehicleTxt));
						if moVehicles[k].area ~= nil then
							moVehicles[k].area = {posX, posX+(moreText)+0.04, firstPosXY+0.002, firstPosXY+0.002+(size+distance)};
						end;
						nextLine(distance, distanceLine);
					end;
				end;				
			end;
		end;
	end;
	setTextBold(false);
end;

function setMenueVI(self)
	nextWidth = moSetGetGui.buttonGfxWidth1*moSetGetGui.pdaVI.zoomOutInVI*7;
end;